/* This file is part of Indico.
 * Copyright (C) 2002 - 2015 European Organization for Nuclear Research (CERN).
 *
 * Indico is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 3 of the
 * License, or (at your option) any later version.
 *
 * Indico is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Indico; if not, see <http://www.gnu.org/licenses/>.
 */

@import 'base';
@import 'compass';
@import 'compass/css3/user-interface';
@import 'compass/support';
@import 'partials/boxes';
@import 'partials/buttons';
@import 'partials/icons';
@import 'partials/toolbars';

// ============================================================================
// Base classes
// ============================================================================

%regform-section {
    @extend .i-box;
    @extend .i-box.titled;
    margin-top: 25px;
}

.regform-section-title {
    @extend %i-box-title;
}

// ============================================================================
// Section display
// ============================================================================

.regform-section {
    @extend %regform-section;
    width:750px;

    .i-box-header {
        table {
            td {
                vertical-align: top;
            }

            .section-header-content {
                width: 100%;
                max-width: 568px;
            }

            .section-toolbar {
                width: 150px;
            }
        }

        .clearableinput + .clearableinput {
            margin-top: 3px;
        }
    }

    .section-field-divisor {
        & > span {
            color: $gray;
            font-size: 1.2em;
            margin-left: 4px;
            vertical-align: -8%;
        }
    }

    .section-group-title {
        font-weight: bold;
        margin-top: 15px;
    }

    .section-placeholder {
        color: $gray;
        font-style: italic;
    }

    .section-sortable-handle {
        @include icon-before('icon-handle');
        @include transition(
            background-color $default-transition-duration $default-transition-function,
            height $default-transition-duration $default-transition-function
        );

        background-color: lighten($dark-gray, $color-variation);
        cursor: move;
        font-size: 1.2em;
        height: 10px;
        margin: -10px -10px 10px -10px;
        text-align: center;

        &:hover,
        &:active {
            @include border-bottom();
            background-color: white;
            height: 20px;

            &:before {
                color: $dark-gray;
                top: 3px;
            }
        }

        &:before {
            @include rotate(90deg);
            @include single-transition(top);
            color: $light-gray;
            display: inline-block;
            position: relative;
            top: -3px;
        }
    }
}

.regform-field {
    @include single-transition(background-color);

    min-height: 27px;
    margin: 2px -10px;
    padding: 0 10px;
    // TODO Any better idea? This is hackish as hell
    width: 102.8%;
    word-break: break-word;

    &.disabled {
        background: $light-gray;

        & .field-caption {
            color: $dark-gray;
        }
    }

    .field-actions {
        visibility: hidden;
        float: right;
        line-height: 27px;
        padding: 0 5px;
        white-space: nowrap;

        a {
            color: $blue;
            display: inline-block;
        }
    }

    .field-caption {
        width: 125px;
        padding: 4px 0;
        vertical-align: top;
    }

    .field-description {
        color: $dark-gray;
        font-size: 11px;
        max-width: 440px;
        text-align: justify;
        padding: 5px 2px 10px 2px;
    }

    .field-input {
        vertical-align: top;
        padding-top: 3px;

        .field-input-only-content {
            display: inline-block;
            max-width: 570px;
            padding-bottom: 3px;
        }
    }
}

// ============================================================================
// Post-registration page
// ============================================================================

.regform-done {
    @extend %regform-section;
    margin-bottom: 15px;

    .regform-done-title {
        @include border-bottom(lighten($gray, $color-variation));
        display: block;
        font-size: 1.3em;
        margin: 15px 0 5px 0;
    }

    tr:first-child .regform-done-title {
        margin-top: 0;
    }

    .regform-done-caption {
        border-bottom: 1px dashed lighten($gray, $color-variation);
        border-right: 1px dashed lighten($gray, $color-variation);
        color: $dark-gray;
        text-align: right;
        padding-right: 8px;
        width: 120px;
    }

    .regform-done-data {
        padding-left: 5px;
        vertical-align: top;
    }

    .regform-done-table-title {
        @include border-bottom(lighten($gray, $color-variation));
        font-weight: bold;

        &:not(:first-child) {
            padding-left: 15px;
        }
    }

    .regform-done-table-item {
        td {
            vertical-align: top;

            &:not(:first-child) {
                padding-left: 15px;
            }
        }

        &:nth-child(odd) {
            background: $light-gray;
        }
    }

    .regform-done-table-total {
        @include border-top(lighten($gray, $color-variation));
        font-weight: bold;
        padding-top: 5px;
    }

    .regform-done-conditions {
        margin-top: 20px;

        input[type=checkbox] {
            float: left;
            margin-left: 1px;
        }

        td:first-child {
            width: 100%;
        }
    }

    .regform-done-checkout {
        font-size: 1.1em;
        margin-top: 10px;
    }

    .not-selected {
        color: $gray;
        font-style: italic;
    }

    .payment-status {
        font-weight: bold;

        &.payment-done {
            color: $green;
        }

        &.payment-pending {
            color: $yellow;
        }

        &.payment-not-paid {
            color: $red;
        }

        i {
            font-size: 1.5em;
            &:before {
                vertical-align: -15%;
            }
        }
    }

    .payment-terms-agreement {
        color: $light-black;
    }
}

.regform-add-field-qtip {
    @include border-all();
    background: white;

    .qtip-content {
        text-align: center;
    }

    .qtip-titlebar {
        @include border-bottom();
        padding: 5px 0;
    }

    .qtip-title {
        color: $light-black;
        text-align: center;
        font-size: 1.2em;
    }

    .ui-tooltip-content {
        padding: 0px;
    }

    .ui-tooltip-titlebar {
        border-bottom: none !important;
        background: transparent;
    }

    .i-big-button {
        margin: 2px 0;
    }
}

.action-button {
    @extend .i-button;
    @extend .i-button.big;
    @extend .i-button.highlight;
    @extend .i-button.next;
    font-weight: bold;
    margin-left: 2em;
    margin-right: 0;
    white-space: nowrap;
}

.permalink-text {
    color: $light-black;
    margin-top: 2em;
    text-align: center;

    .permalink {
        @extend %font-family-monospace;
        color: $light-black;
        font-size: 0.8em;
        margin-top: 0.5em;
        text-align: center;
        width: 100%;
    }
}

// ============================================================================
// Editable-specific
// ============================================================================

.regform-field.editable {
    &:hover,
    &:active {
        background-color: $light-blue;

        .field-actions {
            visibility: visible;
        }
    }
}

.regform-table {
    thead {
        th {
            @include border-bottom();
            padding-bottom: 4px;
            vertical-align: top;
        }

        td {
            background: white !important;
        }

        th:first-of-type {
            text-align: left;
        }
    }

    td, th {
        padding: 4px 4px;
    }

    tr {
        &:hover td {
            background: $light-blue;
        }

        &.empty-row:hover td {
            background: white !important;
        }

        td.row-actions {
            span {
                padding-right: 6px;
            }

            a {
                color: $blue;
                visibility: hidden;
            }
        }

        &:hover td.row-actions a {
            visibility: visible;
        }
    }

    .accompanying-col {
        background: $light-gray;
    }
}

// ============================================================================
// Field-specific
// ============================================================================

.regform-field {
    label {
        font-weight: normal;
    }

    textarea {
        resize: none;
    }

    ul {
        margin: 0;
        padding-left: 0;

        li {
            list-style: none;
        }
    }

    .accommodation-option-item {
        padding-left : 15px;
    }

    .checkbox-info {
        margin: 3px 0 0 21px;
    }

    .label-price {
        margin-left: 2px;
        padding-left: 2px;
    }

    .label-text {
        text-align: justify;
    }

    .file-link {
        @include icon-before('icon-file');
        padding-left: 2px;
    }

    .remove-file {
        @include icon-before('icon-close');
        color: $light-black;
        font-size: 1.1em;

        &:hover {
            color: $red;
        }
    }

    .dateField {
        img {
            right: 22px;
        }

        input[type=text] {
            margin: 0 2px;
        }
    }
}

// ============================================================================
// Section-specific
// ============================================================================

.regform-section {
    textarea.reason-input {
        max-width: 100%;
        width: 100%;
    }
}

// ============================================================================
// Billable-specific
// ============================================================================

.no-currency-selected {
    color: $red;
    vertical-align: -5%;
}

.available-text {
    color: green;
}

.unavailable-text {
    color: red;
}

// ============================================================================
// Dialog-specific
// ============================================================================

.regform-dialog {
    .mandatory-check {
        float: left;
        line-height: 21px;
        position: absolute;

        span {
            vertical-align: 10%;
        }
    }

    .description-input {
        margin: 0 2px;
        width: 345px;
        resize: none;
    }

    .caption-input {
        margin: 0 2px;
        width: 230px;
        resize: none;
    }

    .free-text-input {
        margin: 0 2px;
        width: 260px;
        resize: none;
    }
}

.regFormSectionNewSection {
    @extend %font-family-title-light;
    width:625px;
    font-size: 20px;
    color: #0C4566;
    padding: 10px;
    font-weight: bold;
    margin: 0px;
}

.regFormDialogTabContent {
    margin-top: 20px;
    min-width: 480px;
}

.regFormDialogEditionTable {
    margin-bottom: 20px;
    margin-right: 20px;
}

.regFormDialogIntroText {
    margin-bottom: 15px;
}

.regFormDialogEditLine {
    clear: both;
    margin-right: 30px;
    margin-bottom: 15px;
}

.regFormDialogEditDatesOffset {
    border-collapse: collapse;
    margin-bottom: 15px;

    td {
        padding: 3px;
    }

    tr:not(.regFormDialogCaptionLine) td:first-child {
        padding-left: 20px;
    }

    tr.regFormDialogCaptionLine td {
        padding-top: 0.5em;
    }

    input {
        width: 40px;
    }
}

.regFormDialogCaption {
    margin-top: 3px;
    width: 90px;
    display: inline-block;
    vertical-align: top;
    white-space: normal;
}

.regFormDialogCaptionLine {
    min-width: 180px;
    margin-bottom: 7px
}

.regFormEditLine{
    padding-bottom : 7px;
}

/* Form Display CSS */

.regform-mandatory-info {
    margin: 10px 0px;
    text-align: center;
    color: $black;
    font-style: italic;
}

/* Form Edition CSS */

input.regFormTitleInputMgmt {
    @extend %font-family-title-light;
    width : 600px;
    font-size: 20px;
    color: $dark-blue;
    font-style: normal;
    font-weight: bold;
}

input[name="price"].ng-invalid-required {
    border: 1px solid red;
}

textarea.regFormDescriptionInputMgmt {
    @extend %font-family-description;
    width : 600px;
    font-size: 14px;
    color: rgb(34, 34, 34);
    font-style: italic;
    font-weight: normal;
}

.regFormSectionTable,
.regFormDoneTable {
    border: 1px solid #CCC;
    border-radius: 5px;
    -moz-border-radius: 5px;
    padding: 15px;
    width:70%;
    padding-bottom:10px;
    margin-top: 10px;
}

.regFormMandatoryField {
    color: #812;
    font-weight: normal;
}

/* CSS for the tabs */

.regFormDonePlacesNeeded {
    font-style: italic;
    padding-left: 5px;
}

.row {
  margin-left: -20px;
  *zoom: 1;
}
.row:before,
.row:after {
  display: table;
  content: "";
}
.row:after {
  clear: both;
}
[class*="span"] {
  float: left;
}
.container,
.navbar-fixed-top .container,
.navbar-fixed-bottom .container {
  width: 940px;
}

// ============================================================================
// Tabs-related
// ============================================================================

.tabbable {
  *zoom: 1;
  white-space: nowrap;
}
.tabbable:before,
.tabbable:after {
  display: table;
  content: "";
}
.tabbable:after {
  clear: both;
}
.tabs-left > .nav-tabs {
  border-bottom: 0;
}
.tabs-left > .nav-tabs > li,
.tabs-right > .nav-tabs > li {
  float: none;
}
.tabs-left > .nav-tabs > li > a,
.tabs-right > .nav-tabs > li > a {
  min-width: 74px;
  margin-right: 0;
  margin-bottom: 3px;
}
.tabs-left > .nav-tabs {
  display: inline-block;
  vertical-align: top;
  margin-right: 19px;
  border-right: 1px solid #ddd;
}
.tabs-left > .nav-tabs > li > a {
  margin-right: -1px;
  -webkit-border-radius: 4px 0 0 4px;
  -moz-border-radius: 4px 0 0 4px;
  border-radius: 4px 0 0 4px;
}
.tabs-left > .nav-tabs > li > a:hover {
  border-color: #eeeeee #dddddd #eeeeee #eeeeee;
}
.tabs-left > .nav-tabs .active > a,
.tabs-left > .nav-tabs .active > a:hover {
  border-color: #ddd transparent #ddd #ddd;
  *border-right-color: #ffffff;
}

.nav {
  margin-left: 0;
  margin-bottom: 18px;
  list-style: none;
}
.nav > li > a {
  display: block;
}
.nav > li > a:hover {
  text-decoration: none;
  background-color: #eeeeee;
}
.nav > .pull-right {
  float: right;
}
.nav .nav-header {
  display: block;
  padding: 3px 15px;
  font-size: 11px;
  font-weight: bold;
  line-height: 18px;
  color: #999999;
  text-shadow: 0 1px 0 rgba(255, 255, 255, 0.5);
  text-transform: uppercase;

}
.nav li + .nav-header {
  margin-top: 9px;
}

.nav-tabs > li,
.nav-pills > li {
  float: left;
}
.nav-tabs > li > a,
.nav-pills > li > a {
  padding-right: 12px;
  padding-left: 12px;
  margin-right: 2px;
  line-height: 14px;
}
.nav-tabs {
  border-bottom: 1px solid #ddd;
}
.nav-tabs > li {
  margin-bottom: -1px;
}
.nav-tabs > li > a {
  padding-top: 8px;
  padding-bottom: 8px;
  line-height: 18px;
  border: 1px solid transparent;
  -webkit-border-radius: 4px 4px 0 0;
  -moz-border-radius: 4px 4px 0 0;
  border-radius: 4px 4px 0 0;
}
.nav-tabs > li > a:hover {
  border-color: #eeeeee #eeeeee #dddddd;
}
.nav-tabs > .active > a,
.nav-tabs > .active > a:hover {
  color: #555555;
  background-color: #ffffff;
  border: 1px solid #ddd;
  border-bottom-color: transparent;
  cursor: default;
}
.tab-content {
  display: inline-block;
  overflow: auto;
}
.tabs-below > .nav-tabs,
.tabs-right > .nav-tabs,
.tabs-left > .nav-tabs {
  border-bottom: 0;
}
.tab-content > .tab-pane,
.pill-content > .pill-pane {
  display: none;
}
.tab-content > .active,
.pill-content > .active {
  display: block;
}

// ============================================================================
// Sortable-related
// ============================================================================

%regform-sortable-placeholder {
    background-color: $light-gray;
}

.regform-field-sortable-placeholder {
    @extend %regform-sortable-placeholder;
    @include border-vert($gray, dashed);
    margin: 2px -10px;
    // TODO Any better idea? This is hackish as hell
    width: 102.9%;
}

.regform-section-sortable-placeholder {
    @extend %regform-sortable-placeholder;
    @extend %regform-section;
    @include border-all($gray, dashed);
    @include box-shadow(none);
}

.regform-table-sortable-placeholder {
    background-color: $light-blue;
    line-height: 1.6em;
}

.regform-field.editable {
    .field-sortable-handle {
        color: $dark-gray;
        line-height: 26px;
        vertical-align: top;
        width: 15px;
    }

    &:not(.disabled):hover .field-sortable-handle,
    &:not(.disabled):active .field-sortable-handle {
        @include icon-before('icon-handle');
        cursor: move;
    }
}

.regform-table {
    padding-bottom: 25px;

    tr:hover .table-sortable-handle,
    td:active .table-sortable-handle{
        @include icon-before('icon-handle');
    }

    .table-sortable-handle {
        color: $dark-gray;
        width: 15px;
        cursor: move;
    }
}

// ============================================================================
// Animation-related
// ============================================================================

.regform-section .i-box-header,
.i-button.highlightable {
    @include single-transition(background, 1s, ease-out);
}

.section-highlight-enter .regform-section .i-box-header,
.button-highlight-enter {
    background: $yellow;
}

// ============================================================================
// Contenteditable-related
// ============================================================================

.regform-section .i-box-title,
.regform-section .i-box-description,
.regFormText {
    &[contenteditable]+.button-box {
        a {
            text-shadow: none;
            opacity: 0.5;

            &:hover {
                opacity: 1;
            }

            &:active {
                text-shadow: 1px 1px 1px $gray;
            }
        }

        .input-clear {
            color: $red;

            &:hover {
                color: $red;
            }

            &:active {
                color: $red;
            }
        }

        .input-action {
            color: $green;

            &:hover {
                color: $green;
            }
            &:active {
                color: $green;
            }
        }
    }
}

.regform-section .i-box-description[contenteditable],
.regFormText[contenteditable] {
    &.focus {
        min-height: 27px !important;
    }

    &+.button-box a {
        font-size: 1.5em !important;
        line-height: 27px !important;
    }
}

.regform-section .i-box-description[contenteditable] {
    &.focus {
        padding-right: 3.6em !important;
    }
}

// ============================================================================
// RegistrantsListStats-related
// ============================================================================

.i-box.registrant-stats {
    &> .i-box-header {
        & > .i-box-title { float: left; }
        & > .i-box-header-text {
            color: $light-black;
            font-style: italic;

            &.currency-info {
                @include border-radius();
                font-style: normal;
                font-weight: bold;
                font-size: 0.8em;
                float: right;
                text-align: center;
                color: $light-gray;
                background-color: $dark-blue;
                padding: 0.3em;

            }

            &.headline { clear: both; }
        }
    }
    &> .i-box-content {
        &> table.registrant-stats {
            border-collapse: collapse;

            thead {
                tr:last-child th {
                    font-weight: bold;
                    border-bottom: 2px solid $gray;
                    padding-right: 5px;
                }
                th {
                    padding-right: 10px;
                    text-align: center;
                }
            }
            tbody {
                tr {
                    &:nth-child(even) { background-color: $light-gray; }
                    &:nth-child(odd) { background-color: white; }
                    &:first-child td { border-top: 0; }

                    &:not(.sub-row) td.cancelled-item:first-child {
                        position: relative;

                        &:after {
                            border-bottom: 2px solid $light-black;
                            content: "";
                            left: 1%;
                            position: absolute;
                            right: 1%;
                            top: 48%;
                            width: 98%;
                        }
                    }
                }
                td {
                    border-top: 1px solid $gray;

                    &:first-child, &:last-child { font-weight: bold; }

                    &.paid-unpaid-progress > .i-progress > .i-progress-bar {
                        &:first-child { background: $pastel-green; }
                        &:nth-child(2) { background: $pastel-red; }
                    }
                    &.no-stats-data { color: $dark-gray; }
                    &.paid-amount span { color: $green; }
                    &.unpaid-amount {
                        &:before { content: "("; }
                        &:after { content: ")"; }
                        span { color: $red; }
                    }
                    &.stick-left { padding-right: 1px; }
                    &.stick-right { padding-left: 1px; }
                }
            }
            tr {
                td:first-child:before {
                    display: inline-block;
                    line-height: 1em;
                    font-size: 1.2em;
                    vertical-align: middle;
                    font-weight: bold;
                }
                &.header-row  {
                    cursor: pointer;
                    @include user-select(none);

                    td:first-child {
                        @include icon-before('icon-arrow-down');

                        border-bottom: 0;
                        &:before {
                            @include transition(transform 0.15s ease-out);

                            -webkit-transform-origin: 50%  51%; // improve blurry text on rotate with chrome
                        }
                    }
                    &.collapsed td:first-child:before { @include rotate(-90deg); }
                }
                &.single-row td:first-child:before { content: "\2001"; }
                &.sub-row td:first-child { border-top: 0px; }
            }
            th, td {
                padding: 5px;
                text-align: right;

                &:first-child { text-align: left; }
                i[class^="icon-"] { vertical-align: middle; }
            }
        }

        .stats-overview {
            font-size: 2em;
            font-weight: bold;
            color: $light-black;
            display: block;

            &> *.no-info {
                font-size: 1em;
                color: $dark-gray;
                font-style: italic;
                font-weight: lighter;
            }
            &> *:last-child {
                float: right;
                clear: both;
            }
        }

        .stats-item {
            display: block;
            width: 100%;
            position: relative;
            margin: 0.6em 0;
            font-size: 1.2em;
            height: 1.5em;
            vertical-align: middle;
            color: $black;
            &> * {
                &:first-child {
                    position: relative;
                    line-height: 1.5em;
                    float: left;
                    margin-right: 0.4em;
                }
                &:last-child {
                    display: block;
                    overflow: auto;

                    & > .i-progress {
                        background-color: $pastel-green;

                        & > .i-progress-bar {
                            background-color: $pastel-red;
                        }
                    }
                }
            }
        }

        &> .i-badges-list > .i-badge > .i-badge-content { height: 6.5em; }

        .jqplot-point-label {
            color: white;
            z-index: 100;
        }
        .jqplot-yaxis-tick {
            right: 0;
            margin-right: 0.5em;
        }
        .jqplot-xaxis-tick { margin-top: 0.2em; }
    }

    #countriesPlot {
        @include user-select(none);

        margin-top: -1.2em;
    }
}
